package pencilbox.hakyukoka;

import java.util.ArrayList;

import pencilbox.common.core.Address;
import pencilbox.common.core.Area;
import pencilbox.common.core.BoardCopierBase;
import pencilbox.common.core.Rotator;
import pencilbox.common.core.Rotator2;

/**
 * 
 */
public class BoardCopier extends BoardCopierBase<Board> {

	@Override
	public void copyBoardStates(Board src, Board dst, int n) {
		Rotator rotator = new Rotator(src.getSize(), n);
		rotator.rotateArrayInt2(src.getState(), dst.getState());
		rotator.rotateArrayInt2(src.getNumber(), dst.getNumber());
		for (Area srcArea : src.getAreaList()) {
			Area a = new Area();
			rotator.rotateArea(srcArea, a);
			if (dst.isAreaOn(a)) {
				dst.addArea(a);
			}
		}
	}

	@Override
	public void copyRegion(Board srcBoard, Board board, pencilbox.common.core.Area region, Address from, Address to, int rotation) {
		ArrayList<Area> srcAreaList = new ArrayList<Area>();
		Area srcArea = null;
		Area dstArea = null;
		Address d = new Address();
		Rotator2 rotator = new Rotator2(to, rotation);
		for (Address s : region) {
			d.set(s.r() + to.r() - from.r(), s.c() + to.c() - from.c());
			d.set(rotator.rotateAddress(d));
			if (board.isOn(d)) {
				board.setState(d, srcBoard.getState(s));
				board.setNumber(d, srcBoard.getNumber(s));
				srcArea = srcBoard.getArea(s);
				if (srcArea != null) {
					if (srcAreaList.contains(srcArea))
						continue;
					if (! region.containsAll(srcArea)) // ubNŜIꂽꍇɈړB
						continue;
					srcAreaList.add(srcArea);
					dstArea = new Area();
					for (Address ss : srcArea) {
						if (region.contains(ss)) {
							Address dd = new Address(ss.r() + to.r() - from.r(), ss.c() + to.c() - from.c());
							dd.set(rotator.rotateAddress(dd));
							if (board.isOn(dd))
								dstArea.add(dd);
						}
					}
					if (dstArea.size() < srcArea.size()) // ubNS̈ړ̂ƂCړŃubNՊOɂ͂ݏoꍇ̓ubN
						continue;
					for (Address dd : dstArea) {
						if (board.getArea(dd) != null) {
							board.removeArea(board.getArea(dd));
//							board.removeCellFromArea(dd, board.getArea(dd));
						}
					}
					board.addArea(dstArea);
				}
			}
		}
	}

	@Override
	public void eraseRegion(Board board, pencilbox.common.core.Area region) {
		for (Address s : region) {
			board.setState(s, Board.UNSTABLE);
			board.setNumber(s, Board.UNKNOWN);
			Area srcArea = board.getArea(s);
			if (srcArea != null) {
				if (!region.containsAll(srcArea)) // ubNŜIꂽꍇɏB
					continue;
				board.removeCellFromArea(s, srcArea);
			}
		}
	}

}
