package pencilboxex;

import pencilbox.common.core.BoardBase;
import pencilbox.common.core.PencilBoxException;
import pencilbox.common.factory.ClassUtil;
import pencilbox.common.factory.Constants;
import pencilbox.common.factory.PencilBoxClassException;
import pencilbox.common.gui.MenuCommand;
import pencilbox.common.gui.PanelBase;

/**
 * gj[R}h
 */
public class MenuCommandEx<T extends BoardBase, P extends PanelBase<T>> extends MenuCommand<T, P> {
	
	//TuNXނ݂₽ɍ̂͂܂萫ɍȂ̂
	//MenuȊŐʕ̔h͂̃NXɏW
	/** \o[̃NX */
	private static final String SOLVER_CLASS = "Solver";
	
	/**
	 * t[^Cgݒ肷
	 * ҏW̃pY̎ނƃt@C\
	 */
	@Override
	protected void setFrameTitle() {
		getFrame().setTitle(getProblem().getFileName() + " - " + getPencilType().getTitle() + " - " + Constants.TITLE);
	}

	/**
	 * \o[Nł邩ǂԂ
	 */
	public boolean isSolverSupported() {
		
		//Lb`̂߂ǂ̂Ŏ蔲
		try {
			ClassUtil.createInstance(getPencilType(), SOLVER_CLASS);
		} catch (PencilBoxClassException e) {
			return false;
		}
		
		return true;
	}
	
	/**
	 * \o[N
	 */
	public void launchSolver() {
		
		try {
			SolverBase<T> solver = ClassUtil.createInstance(getPencilType(), SOLVER_CLASS);
			
			SolverDialog.<T>start(getFrame(), solver, getProblem().getBoard());
			
		} catch (PencilBoxException e) {
			showErrorMessage(e);
		}
	}
}
