package pencilboxex;

import java.awt.event.InputEvent;

import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

import pencilbox.common.core.BoardBase;
import pencilbox.common.gui.MenuBase;
import pencilbox.common.gui.PanelBase;

/**
 * gj[NX
 */
public class MenuExBase<T extends BoardBase, P extends PanelBase<T>, S extends MenuCommandEx<T, P>> extends MenuBase<T, P, S> {
	
	/** [\o[N]j[ACe */
	private JMenuItem launchSolverItem;
	
	/**
	 * [ҏW]j[ɒǉƎj[쐬
	 * <p>
	 * KvɉĊeTuNXŃI[o[ChB
	 * eTuNXł́A
	 * <ul>
	 * <li>addSeparatorToEditMenu()</li>
	 * <li>addToEditMenu(JMenuItem)</li>
	 * </ul>
	 * pēƎj[ǉB
	 * </p>
	 */
	@Override
	protected void buildExtentionEditMenu() {
		super.buildExtentionEditMenu();
		if (isSolverSupported()) {
			addToEditMenu(launchSolverItem = makeCommandMenuItem("\o[N(L)", 'L'));
			addSeparatorToEditMenu();
		}
	}
	
	/**
	 * ǂ̃j[IꂽׂāCΉR}hNB
	 * eTuNXŃI[o[ChB
	 * @param target Iꂽj[
	 */
	@Override
	public void executeCommand(JMenuItem target) {
		if (target == launchSolverItem) {
			launchSolver();
		} else {
			super.executeCommand(target);
		}
	}
	
	/**
	 * [ҏW]-[\o[N]
	 */
	protected void launchSolver() {
		getMenuCommand().launchSolver();
	}
	
	/**
	 * [ҏW]-[\o[N]T|[g邩ǂ擾
	 * 
	 * @return [ҏW]-[\o[N]T|[g邩ǂ
	 */
	protected boolean isSolverSupported() {

		return getMenuCommand().isSolverSupported();
	}
	
	/**
	 * 
	 * @see pencilbox.common.gui.MenuBase#setAccelerators()
	 */
	@Override
	protected void setAccelerators() {
		super.setAccelerators();
		if (launchSolverItem != null) {
			launchSolverItem.setAccelerator(
					KeyStroke.getKeyStroke('L',	InputEvent.CTRL_MASK | InputEvent.ALT_MASK));
		}
	}
}
