package solver;

/**
 * \o[̊NXłB
 */
public abstract class AbstractSolver<T extends State<S>, S> implements Solver<T> {
	
	/**
	 * \o[N܂
	 * 
	 * ł solve(state, 1, true) ĂсA̖߂lԂ܂B
	 * 
	 * @param state 
	 * @return 
	 * @throws InterruptedException
	 * @see solver.Solver#start(java.lang.Object)
	 */
	public int start(T state) throws InterruptedException {
		return solve(state, 1, true);
	}
	
	/**
	 * \o[N܂
	 * 
	 * {\bh͉ȂP邩Qȏ゠邩𔻒f邱ƂړIƂ܂B
	 * 
	 * @param state 
	 * @param level x
	 * @param deep ݂Ԃsǂ
	 * @return 
	 * @throws InterruptedException
	 */
	public int solve(T state, int level, boolean deep) throws InterruptedException {
		
		//܂͊m肷ӏ肷
		int result = solveFixed(state);
		if (result != UNSOLVED) {
			return result;
		}
		T complateState = null;
		//xw̍ċAs܂
		if (level > 0) {
			//p̃|C^[擾
			AssumePointer<T, S> pointer = getAssumePointer(state);
			//pointer.forward() ł܂킷[v
			while (true) {
				S entry = pointer.forward();
				
				if (entry == null) {
					break;
				}
				
				boolean denyFlag = false;
				int unsolvedCount = 0;
				T unsolvedState = null;
				boolean find = false;
				
				//forword̈ʒuł肦p^[ׂĎ܂
				//pointer.next() ł܂킷[v
				do {
					Thread.sleep(0);
					T child = copy(state);
					child.apply(entry);
					
					switch (solve(child, level - 1, false)) {
					case NORESULT:
						denyFlag = state.deny(entry);
						break;
					case UNSOLVED:
						if (unsolvedCount == 0) {
							unsolvedState = child;
						}
						++unsolvedCount;
						break;
					case COMPLATE:
						find = true;
						if (complateState == null) {
							complateState = child;
						} else if (!complateState.equals(child)) {
							return MULTI;
						}
						break;
					case MULTI:
						return MULTI;
					}
				} while ((entry = pointer.next()) != null);
				
				if (find) {
					if (unsolvedCount == 0) {
						copy(complateState, state);
						return COMPLATE;
					} else if (unsolvedCount == 1) {
						switch (solveFirstHit(unsolvedState, level, deep)) {
						case NORESULT:
							copy(complateState, state);
							return COMPLATE;
						case COMPLATE:
						case MULTI:
							return MULTI;
						}
					}
				} else {
					if (unsolvedCount == 1) {
						copy(unsolvedState, state);
						pointer = getAssumePointer(state);
						continue;
					}
				}
				if (denyFlag) {
					result = solveFixed(state);
					if (result != UNSOLVED) {
						return result;
					}
					pointer = getAssumePointer(state);
					continue;
				}
			} //while(pointer.forward())
		}
		if (deep) {
			return solveDeep(state, complateState);
		}
		return result;
	}
	
	/**
	 * \o[NA݂邩ǂ𔻒f܂B
	 * 
	 * {\bh͉邩ǂ𔻒f邱ƂړIƂ܂B
	 * ʂ COMPLATE łĂPłƂ͌܂B
	 * 
	 * @param state 
	 * @param level x
	 * @param deep ݂Ԃsǂ
	 * @return 
	 * @throws InterruptedException
	 */
	private int solveFirstHit(T state, int level, boolean deep) throws InterruptedException {
		//܂͊m肷ӏ肷
		int result = solveFixed(state);
		if (result != UNSOLVED) {
			return result;
		}
		//xw̍ċAs܂
		if (level > 0) {
			//p̃|C^[擾
			AssumePointer<T, S> pointer = getAssumePointer(state);
			//pointer.forward() ł܂킷[v
			while (true) {
				S entry = pointer.forward();
				if (entry == null) {
					break;
				}
				boolean denyFlag = false;
				int unsolvedCount = 0;
				T unsolvedState = null;
				
				//forword̈ʒuł肦p^[ׂĎ܂
				//pointer.next() ł܂킷[v
				do {
					Thread.sleep(0);
					T child = copy(state);
					child.apply(entry);
					//
					switch (solveFirstHit(child, level - 1, false)) {
					case NORESULT:
						denyFlag = state.deny(entry);
						break;
					case UNSOLVED:
						if (unsolvedCount == 0) {
							unsolvedState = child;
						}
						++unsolvedCount;
						break;
					case COMPLATE:
						copy(child, state);
						return COMPLATE;
					case MULTI:
						return MULTI;
					}
				} while ((entry = pointer.next()) != null);
				
				if (unsolvedCount == 1) {
					copy(unsolvedState, state);
					pointer = getAssumePointer(state);
					continue;
				}
				if (denyFlag) {
					result = solveFixed(state);
					if (result != UNSOLVED) {
						return result;
					}
					pointer = getAssumePointer(state);
					continue;
				}
			} //while(pointer.forward())
		}
		if (deep) {
			return solveDeepFirstHit(state);
		}
		return result;
	}

	/**
	 * ݂ԂpĈ̏ԂǂԂ܂
	 * 
	 * P𔭌ꍇAstateɉݒ肵܂B
	 * łɌĂnꍇAƈقȂ𔭌ꍇA̎_ MULTI Ԃ܂B
	 * 
	 * @param state ݂̏ԁBnullnȂ
	 * @param complateState łɌĂBȂꍇnull
	 * @return ̏Ԃǂ
	 * @throws InterruptedException [ULZsۂɔ܂
	 */
	protected int solveDeep(T state, T complateState) throws InterruptedException {

		AssumePointer<T, S> pointer = getAssumePointer(state);
		S entry = pointer.forward();
		if (entry == null) {
			return UNSOLVED;
		}
		T workComplateState = null;
		do {
			Thread.sleep(0);
			T child = copy(state);
			child.apply(entry);
			int result = solveFixed(child);
			if (result == UNSOLVED) {
				result = solveDeep(child, complateState);
			}
			switch (result) {
			case COMPLATE:
				if (complateState != null && !complateState.equals(child)) {
					return MULTI;
				}
				if (workComplateState == null) {
					workComplateState = child;
				} else {
					return MULTI;
				}
				break;
			case MULTI:
			case UNSOLVED:
				return result;
			}
		} while ((entry = pointer.next()) != null);
		
		if (workComplateState != null) {
			copy(workComplateState, state);
			return COMPLATE;
		} else {
			return NORESULT;
		}
	}
	
	/**
	 * ݂ԂpĈ̏ԂǂԂ܂
	 * 
	 * 𔭌ꍇAstateɉݒ肵܂B
	 * {\bh͉邩ǂ𔻒f邱ƂړIƂ܂B
	 * ʂ COMPLATE łĂPłƂ͌܂B
	 * 
	 * @param state ݂̏ԁBnullnȂ
	 * @return ̏Ԃǂ
	 * @throws InterruptedException [ULZsۂɔ܂
	 */
	protected int solveDeepFirstHit(T state) throws InterruptedException {

		AssumePointer<T, S> pointer = getAssumePointer(state);
		S entry = pointer.forward();
		if (entry == null) {
			return UNSOLVED;
		}
		do {
			Thread.sleep(0);
			T child = copy(state);
			child.apply(entry);
			int result = solveFixed(child);
			if (result == UNSOLVED) {
				result = solveDeepFirstHit(child);
			}
			switch (result) {
			case COMPLATE:
				copy(child, state);
				return COMPLATE;
			case MULTI:
			case UNSOLVED:
				return result;
			}
		} while ((entry = pointer.next()) != null);
		
		return NORESULT;
	}
	
	/**
	 * m肵Ăӏ̂݉𓚂s܂
	 * 
	 * m肵ӏ͈stateɏ㏑ĂB
	 * ł͉sKv̂Ȃ݂̏̂悤ɂĂB
	 * m肵ӏ𖄂߂ʂɂāAȉ̒lԂĂB
	 * E܂m̏ꏊꍇFUNSOLVED
	 * EĒPꍇFCOMPLATE
	 * E݂ȂꍇFNORESULT
	 * EꍇFMULTI
	 * 
	 * {\bh񂠂̏ԂςꍇAiڈƂĂ10msxj
	 * ɓKXAThread.sleep(0) s悤ɂĂB
	 * [ULZsꍇÃ\bhĂяo^C~OŁA
	 * InterruptedException ܂B
	 * 
	 * @param state ԁBm肵ӏ͂̃IuWFNgɏ㏑BnullnȂ
	 * @return m肵ӏ𖄂߂ʁiUNSOLVEDACOMPLATEANORESULTAMULTÎꂩzj
	 * @throws InterruptedException [ULZsۂɔ܂
	 */
	public abstract int solveFixed(T state) throws InterruptedException;
	
	/**
	 * Ԃ̃Rs[𐶐܂
	 * 
	 * @param state ԁBnullnȂ
	 * @return ̃Rs[
	 */
	protected abstract T copy(T state);
	
	/**
	 * Ԃ̃Rs[s܂
	 * 
	 * @param src \[XBnullnȂ
	 * @param dst Rs[sΏہBnullnȂ
	 */
	protected abstract void copy(T src, T dst);
	
	/**
	 * ̏Ԃ̉̃|C^擾܂
	 * 
	 * ̃\bhłnullԂĂ͂܂
	 * 
	 * @param state 
	 * @return ̏Ԃ̉̃|C^
	 */
	protected abstract AssumePointer<T, S> getAssumePointer(T state);
}
