package solver.rippleeffect;

public class Area {
	
	final Cell[] cells;
	final int[] count;
	boolean changed = false;
	
	public Area(Cell[] cells) {
		this.cells = cells;
		count = new int[cells.length];
		for (int i = 0; i < cells.length; ++i) {
			count[i] = cells.length;
		}
	}
	
	public void set(Area src) {
		int[] srcCount = src.count;
		for (int i = 0; i < srcCount.length; ++i) {
			count[i] = srcCount[i];
		}
		changed = src.changed;
	}
	
	@Override
	public String toString() {
		
		StringBuffer buffer = new StringBuffer();
		
		if (changed) {
			buffer.append('*');
		}
		buffer.append('[');
		for (int i = 0; i < count.length; ++i) {
			if (i != 0) {
				buffer.append(", ");
			}
			buffer.append(count[i]);
		}
		buffer.append(']');
		
		return buffer.toString();
	}
}
