package solver.rippleeffect;

import java.util.ArrayList;

import solver.AssumePointer;

public class Pointer extends AssumePointer<SolveState, Entry> {
	
	/** ԍ̃CfbNX */
	private int numberIndex;
	/** ̃CfbNX */
	private int roomIndex;
	/** Z̃CfbNX */
	private int cellIndex;
	
	public Pointer(SolveState state) {
		super(state);
	}

	@Override
	public Entry forward() {
		
		ArrayList<Area> areas = state.areas;
		int size = areas.size();
		int[] indexes = state.indexes;
		
		while (true) {
			//܂͈i߂
			if (numberIndex < 0) {
				//
				numberIndex = 0;
				roomIndex = 0;
			} else {
				++roomIndex;
				if (roomIndex >= size) {
					++numberIndex;
					if (numberIndex >= indexes.length) {
						return null;
					}
					roomIndex = 0;
				}
			}
			
			int number = indexes[numberIndex];
			Area area = areas.get(roomIndex);
			Cell[] cells = area.cells;
			
			if (cells.length >= number && area.count[number - 1] > 1) {
				int flag = (1 << (number - 1));
				for (cellIndex = 0; cellIndex < cells.length; ++cellIndex) {
					Cell cell = cells[cellIndex];
					if ((cell.flag & flag) != 0) {
						return new Entry(cell.x, cell.y, number, flag);
					}
				}
			}
		}
	}

	@Override
	public Entry next() {
		//tO擾
		int number = state.indexes[numberIndex];
		int flag = (1 << (number - 1));
		Cell[] cells = state.areas.get(roomIndex).cells;
		for (++cellIndex; cellIndex < cells.length; ++cellIndex) {
			Cell cell = cells[cellIndex];
			if ((cell.flag & flag) != 0) {
				return new Entry(cell.x, cell.y, number, flag);
			}
		}
		
		return null;
	}

	public void init() {
		numberIndex = -1;
		roomIndex = 0;
		cellIndex = 0;
	}
	
	@Override
	public String toString() {
		return "n=" + numberIndex + ", r=" + roomIndex + ", c=" + cellIndex;
	}
}
