package solver.rippleeffect;

import java.util.ArrayList;

import solver.AbstractSolver;
import solver.AssumePointer;

/**
 * gyʃ\o[̎
 */
public class SolverImpl extends AbstractSolver<SolveState, Entry> {
	
	/**
	 * 𓚂s܂
	 * 
	 * {Ã\bhI[oChKv͂Ȃ̂łA
	 * gyʂ̏ꍇAx0łɓ삷邽߂0w肵Ă܂B
	 * 
	 * @param state 
	 * @return 
	 * @throws InterruptedException
	 * @see solver.AbstractSolver#start(solver.State)
	 */
	@Override
	public int start(SolveState state) throws InterruptedException {
		return solve(state, 0, true);
	}
	
	/**
	 * m肵Ăӏ̂݉𓚂s܂
	 * 
	 * @return
	 * @throws InterruptedException
	 * @see solver.AbstractSolver#solveFixed()
	 */
	@Override
	public int solveFixed(SolveState state) throws InterruptedException {
		
		int width = state.width;
		int height = state.height;
		Cell[][] board = state.board;
		final ArrayList<Area> areas = state.areas;
		
		//܂͓肤鐔Ȃ̂`FbN
		while (true) {
			boolean solved = true;
			boolean changed = false;
			
			for (int y = 0; y < height; ++y) {
				Cell[] array = board[y];
				for (int x = 0; x < width; ++x) {
					Cell cell = array[x];
					
					if (cell.area != null && cell.number == 0) {
						solved = false;
						if (cell.changed) {
							cell.changed = false;
							
							int flag = cell.flag;
							
							if (flag != 0) {
								if ((flag & (flag - 1)) == 0) {
									state.setNumber(x, y, Util.bitToNum(flag));
									changed = true;
								}
							} else {
								return NORESULT;
							}
						}
					}
				}
			}
			if (changed) {
				continue;
			}
			if (solved) {
				return COMPLATE;
			}
			int size = areas.size();
			
			for (int index = 0; index < size; ++index) {
				Area area = areas.get(index);
				if (area.changed) {
					area.changed = false;
					
					int[] count = area.count;
					Cell[] cells = area.cells;
					for (int num = 1; num <= cells.length; ++num) {
						switch (count[num - 1]) {
						case 1:
						{
							int flag = 1 << (num - 1);
							for (int i = 0; i < cells.length; ++i) {
								Cell cell = cells[i];
								if ((cell.flag & flag) != 0) {
									state.setNumber(cell.x, cell.y, num);
									changed = true;
								}
							}
						}
							break;
						case 0:
							return NORESULT;
						}
					}
				}
			}
			if (changed) {
				continue;
			}
			break;
		}
		
		return UNSOLVED;
	}

	@Override
	protected AssumePointer<SolveState, Entry> getAssumePointer(SolveState state) {

		return state.getPointer();
	}

	@Override
	protected SolveState copy(SolveState state) {
		return new SolveState(state);
	}

	@Override
	protected void copy(SolveState src, SolveState dst) {
		dst.set(src);
	}
}
